#define STS_PORT 0
#define CMD_PORT 0
#define DAT_PORT 2
#define FLG_PORT 4

#define	SetCmd(x) epn_outpw( CMD_PORT, x )
#define SetDat(x) epn_outpw( DAT_PORT, x ) 
#define	GetSts( ) epn_inpw( STS_PORT )
#define	GetDat( ) epn_inpw( DAT_PORT )
#define	GetFlg( ) epn_inpw( FLG_PORT )

/* ---------------- */
/*  VK^Œ`  */
/* ---------------- */
typedef	unsigned char	EPN_BYTE;
typedef	unsigned short	EPN_WORD;
typedef	unsigned long	EPN_DWORD;

#define	FLG_STAUS_FULL    0x01
#define	FLG_READ_FULL     0x02
#define	FLG_COMMAND_FULL  0x04
#define	FLG_WRITE_FULL    0x08
#define	FLG_WRITE_ENABLE  0x10

/* -----------------*/
/*	Xe[^Xԍ  */
/* -----------------*/
#define	STS_WRITE    1 // f[^|[gɏ݂Ă 
#define	STS_READ     2 // f[^|[gǂł   
#define	STS_OK       3 // ɏ󂯕t܂      
#define	STS_WORKING	 4 // [_̏Ԃsł             
#define	STS_INVALID  5 // S1S60K̏ԂT|[gĂȂ 
#define	STS_ERROR    6 // G[N܂             
#define	STS_BUSY     7 // \[Xsł              
#define	STS_CANCEL   8 // ̌̔񓯊Ɏs        
#define	STS_EVENT   10 // f[^|[gǂł     
#define	STS_BOOT    11 // S1S60KN܂             
#define	STS_ARRIVE  13 // f[^M܂@@@@@@ 
#define	STS_SLEEP   14 // SLEEP[hɂȂ܂          
#define	STS_WAKE    15 // ʏ퓮ԂɂȂ܂        

/* ---------- */
/*	R}h  */
/* ---------- */
#define CMD_OPEN     0 // ʐM[_ݒ肵Apn߂
#define	CMD_SEND     1 // ʐM[_f[^𑗐M
#define	CMD_RECEIVE  2 // ʐM[_ɓ͂f[^M
#define	CMD_CLOSE    4 // ʐM[_̗pI
#define	CMD_ABORT    5 // ʐM[_̗pI ( ً} )
#define	CMD_STOP     6 // ʐM[_Ńf[^ʐM̃R}h𒆎~
#define	CMD_STATUS   7 // ʐM[_AԂɂω擾
#define	CMD_INIT     8 // S1S60K
#define	CMD_INFO     9 // ʐM[_AԂɂω̂Ȃ擾

/* ---------- */
/*	ʐM[_  */
/* ---------- */
#define	ENDPOINT_SYSTEM    0x00
#define	ENDPOINT_DATALINK  0x10
#define	ENDPOINT_TCP0      0x20
#define	ENDPOINT_TCP1      0x30
#define	ENDPOINT_TCP2      0x40
#define	ENDPOINT_TCP3      0x50
#define	ENDPOINT_UDP0      0x60
#define	ENDPOINT_UDP1      0x70
#define	ENDPOINT_UDP2      0x80
#define	ENDPOINT_UDP3      0x90
#define	ENDPOINT_SNMP      0xA0

/* ------------------------ */
/*	@\̃Zbg^Zbg  */
/* ------------------------ */
#define	ENB_DATALINK			0x80 // f[^Nw g / gȂ
#define	ENB_FCS                 0x80 // FCS            ܂ / ܂܂Ȃ
#define	ENB_MORE_DATA           0x80 

#define	ENB_ACTIVE              0x80 // passive / active open
#define	ENB_REMOTE_IP			0x40 // IP         L / 
#define	ENB_REMOTE_PORT         0x20 
#define	ENB_SELF_PORT			0x10 

#define	ENB_SELF_IP             0x40 // gIPAhX L / 
#define ENB_SUBMASK             0x20 // Tulbg}XN L /  
#define ENB_GATEWAY             0x10 // Q[gEFC     L / 

#define	ENB_PROMISCOUS			0x40 // u[hLXg




#define	DISABLE_MULTICAST		0x20	/* Not receive multicast frame	*/


#define	S1S60_ENABLE_GATEWAY			0x10	/* Enable default gateway		*/

#define	S1S60_DISABLE_SELF_IP			0x10	/* Disable self ip				*/
#define	S1S60_ENABLE_WRITE_COMMUNITY	0x10	/* Enable community (write)		*/

#define	S1S60_ENABLE_READ_COMMUNITY		0x08	/* Enable community (read)		*/
#define	S1S60_ENABLE_CONTROL			0x08	/* Enable control flag			*/

#define	S1S60_ENABLE_TIMEOUT			0x04	/* Enable Timeout				*/

#define	S1S60_ENABLE_PRIVATE_MIB		0x02	/* Exist private mib bit		*/
#define	S1S60_ENABLE_DATAOFFSET			0x02	/* Enable data offset flag bit	*/

#define	S1S60_ENABLE_ENTERPRISE			0x01	/* Enable Enterprise bit		*/
#define	S1S60_ENABLE_FULL_LENGTH		0x01	/* Enable full data length		*/
#define	S1S60_ENABLE_NOT_CONNECT		0x01	/* Cable not connect flag		*/

/* R}hIvV */
typedef	struct	{
	EPN_WORD   Zero1;      // f[^̃oCg@OɃZbg
	EPN_BYTE   Flag;       // tO       
	EPN_BYTE   Zero2;   
	EPN_DWORD  RemoteIP;   // ho
	EPN_WORD   RemotePORT; // |[gԍ
	EPN_WORD   SourcePORT; // M|[gԍ
	EPN_WORD   TimeOut;
	EPN_WORD   Zero3;
} EpnOpenUDP;

extern EpnOpenUDP UDP;

